#!/bin/bash -f
#
SCRIPTHOME="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
SCRIPTHOME=$PWD

unset FTP_PROXY
unset ALL_PROXY
unset HTTPS_PROXY
unset HTTP_PROXY
export NO_PROXY=localhost

# ulimit -Sc unlimited

ARGS=$*
SHMLOG=""
APP="t1"
KVER=3.2
START_PORT="12345"
REBUILD=""
TRAP=""
OP=""
SHM=0
LOG=0
POOL=0
LOGS="/tmp/t1"
LAYOUT="blackberry"
INSTANCES=1
MEM=0
SYSTEM=""
REGION="d"
RLWRAP="/usr/local/bin/rlwrap"

export SHELL=/bin/bash

while [ $# -ge 1 ]; do
    case "$1" in
    					--)
            # No more options left.
            shift
            break
            ;;
         --app)
            APP="$2"
            shift
            ;;
        --shmlog)
            SHMLOG="1"
            shift
            ;;
	--rebuild)
	    REBUILD="$2"
            shift
	    ;;
	--trap)
	    TRAP="$2"
            shift
	    ;;
	--pool)
	    POOL="$2"
            shift
	    ;;
	--mem)
	    MEM="$2"
            shift
	    ;;
	--system)
	    SYSTEM="$2"
            shift
	    ;;
	--region)
	    REGION="$2"
            shift
	    ;;
	--log)
	    LOG="$2"
            shift
	    ;;
	--shm)
	    SHM="$2"
            shift
	    ;;
	--layout)
	    LAYOUT="$2"
            shift
	    ;;
	--instances)
	    INSTANCES="$2"
            shift
	    ;;
	--logs)
	    LOGS="$2"
            shift
            ;;
        --restart)
            OP="restart"
            shift
            ;;
        --start)
            OP="start"
            shift
            ;;
        --stop)
            OP="stop"
            shift
            ;;
    esac
    shift
done

APP_HOME="$SCRIPTHOME"/$APP
cd $APP_HOME

startt1 () {
    OPTS=""
    OPTS1=""
    INSTANCE=1
    while [ $INSTANCE -le $INSTANCES ]
    do
     mv /tmp/$t1.${INSTANCE}.start.log /tmp/$t1.${INSTANCE}.start_`date +%y.%m.%d.%H:%M`.log
     touch /tmp/$t1.${INSTANCE}.start.log
     chmod 666 /tmp/$t1.${INSTANCE}.start.log
     R="$OPTS screen -c scripts/startscreenrc -L -d -m -t t1 -S t1.$INSTANCE.start $RLWRAP -c $OPTS1 q t1.q -p $START_PORT -bSHM $SHM -iINSTANCE $INSTANCE -bMEM $MEM -bREBUILD $REBUILD -*LAYOUT $LAYOUT -bTRAP $TRAP -bLOG $LOG -sSYSTEM $SYSTEM -sREGION $REGION -iPOOL $POOL -*LOGS $LOGS"
     echo "Starting $APP: $R"
     $R
     INSTANCE=$[$INSTANCE + 1]
     START_PORT=$[START_PORT + 1]
    done
}

dostart () {
    TEST=`curl --noproxy '*' -s http://localhost:$START_PORT`
    [[ $TEST ]] && echo "$APP already running on $START_PORT!"
    [[ $TEST ]] && exit -1
    startt1
}

doit () {
    case "$1" in 
    start)
        dostart
        ;;
    stop)
        kelfs
        ;;
    restart)
        kelfs
        dostart
        ;;
    esac
}

doit $OP

